#ifndef OBJ_SHOT_H_
#define OBJ_SHOT_H_

struct g_obj_shot {
  unsigned int iparent;  /* instanceid of parent-object */
  struct vg3_rect rect;  /* position of shot (and collision rectangle) */
  int xdelta, ydelta;    /* moving shot in x- and y-direction */
  int xremainder, yremainder;  /* remainders of shot-moving */
  int loop;              /* number of loops shot is running */
  int destroy_me;        /* whether shot can destroy own tank, is set to 1 after first collision of shot with wall */
  struct vg3_image *img; /* image of shot */
  struct vg3_image_attributes iattr;  /* image attributes of shot (rotating) */
  struct {               /* for exploding sprite */
    struct vg3_sprite *sprt;  /* sprite */
    struct vg3_image *img;    /* actual sprite-image */
    struct vg3_image_attributes iattr;  /* image attributes of actual sprite-image as in sprite defined */
  } expl;
};

/* struct for individual functions */
struct g_obj_shot_privfunc {
  void (*f_explode)(void *, struct vg3_ofunc_object *);  /* individual function for creating exploding sprite */
};

#endif /* OBJ_SHOT_H_ */
